# C 程序：使用多维数组将两个矩阵相乘

> 原文： [https://www.programiz.com/c-programming/examples/matrix-multiplication](https://www.programiz.com/c-programming/examples/matrix-multiplication)

#### 在此示例中，您将学习将两个矩阵相乘并使用用户定义的函数进行显示。

要理解此示例，您应该了解以下 [C 编程](/c-programming "C tutorial")主题：

*   [C 数组](/c-programming/c-arrays)
*   [C 多维数组](/c-programming/c-multi-dimensional-arrays)

* * *

该程序要求用户输入两个矩阵的大小（行和列）。

为了将两个矩阵相乘，**第一个矩阵的列数应等于第二个矩阵的行数**。

下面的程序要求两个矩阵的行数和列数，直到满足上述条件。

然后，执行两个矩阵的相乘，结果显示在屏幕上。

为此，我们创建了三个功能：

*   `enterData()` - 从用户那里获取矩阵元素。
*   `multiplyMatrices()` - 将两个矩阵相乘。
*   `display()` - 显示相乘后的结果矩阵。

* * *

## 通过将矩阵传递给函数来相乘

```c
#include <stdio.h>
void enterData(int first[][10], int second[][10], int r1, int c1, int r2, int c2);
void multiplyMatrices(int first[][10], int second[][10], int multResult[][10], int r1, int c1, int r2, int c2);
void display(int mult[][10], int r1, int c2);

int main() {
    int first[10][10], second[10][10], mult[10][10], r1, c1, r2, c2;
    printf("Enter rows and column for the first matrix: ");
    scanf("%d %d", &r1, &c1);
    printf("Enter rows and column for the second matrix: ");
    scanf("%d %d", &r2, &c2);

    // Taking input until columns of the first matrix is equal to the rows of the second matrix
    while (c1 != r2) {
        printf("Error! Enter rows and columns again.\n");
        printf("Enter rows and columns for the first matrix: ");
        scanf("%d%d", &r1, &c1);
        printf("Enter rows and columns for the second matrix: ");
        scanf("%d%d", &r2, &c2);
    }

    // Function to take matrices data
    enterData(first, second, r1, c1, r2, c2);

    // Function to multiply two matrices.
    multiplyMatrices(first, second, mult, r1, c1, r2, c2);

    // Function to display resultant matrix after multiplication.
    display(mult, r1, c2);

    return 0;
}

void enterData(int first[][10], int second[][10], int r1, int c1, int r2, int c2) {
    printf("\nEnter elements of matrix 1:\n");

    for (int i = 0; i < r1; ++i) {
        for (int j = 0; j < c1; ++j) {
            printf("Enter a%d%d: ", i + 1, j + 1);
            scanf("%d", &first[i][j]);
        }
    }
    printf("\nEnter elements of matrix 2:\n");

    for (int i = 0; i < r2; ++i) {
        for (int j = 0; j < c2; ++j) {
            printf("Enter b%d%d: ", i + 1, j + 1);
            scanf("%d", &second[i][j]);
        }
    }
}

void multiplyMatrices(int first[][10], int second[][10], int mult[][10], int r1, int c1, int r2, int c2) {

    // Initializing elements of matrix mult to 0.
    for (int i = 0; i < r1; ++i) {
        for (int j = 0; j < c2; ++j) {
            mult[i][j] = 0;
        }
    }

    // Multiplying first and second matrices and storing in mult.
    for (int i = 0; i < r1; ++i) {
        for (int j = 0; j < c2; ++j) {
            for (int k = 0; k < c1; ++k) {
                mult[i][j] += first[i][k] * second[k][j];
            }
        }
    }
}

void display(int mult[][10], int r1, int c2) {

    printf("\nOutput Matrix:\n");
    for (int i = 0; i < r1; ++i) {
        for (int j = 0; j < c2; ++j) {
            printf("%d  ", mult[i][j]);
            if (j == c2 - 1)
                printf("\n");
        }
    }
} 
```

**输出**

```c
Enter rows and column for the first matrix: 2
3
Enter rows and column for the second matrix: 3
2

Enter elements of matrix 1:
Enter a11: 3
Enter a12: -2
Enter a13: 5
Enter a21: 3
Enter a22: 0
Enter a23: 4

Enter elements of matrix 2:
Enter b11: 2
Enter b12: 3
Enter b21: -9
Enter b22: 0
Enter b31: 0
Enter b32: 4

Output Matrix:
24  29
6  25 
```