# C++ 程序：HelloWorld

> 原文： [https://www.programiz.com/cpp-programming/examples/print-sentence](https://www.programiz.com/cpp-programming/examples/print-sentence)

#### 在此示例中，我们将学习在 C++ 编程中创建一个名为 HelloWorld 的简单程序。

**HelloWorld** 是输出的简单程序，世界！ 屏幕上的。 由于它是一个非常简单的程序，因此经常用于向新手介绍一种新的编程语言。

让我们看看 C++ 的有效 **HelloWorld** 程序。

如果尚未设置在计算机上运行 C++ 的环境，请访问在计算机上安装 *C++*。

* * *

## C++ **HelloWorld** 程序

```cpp
// Your First C++ Program

#include <iostream>

int main() {
    std::cout << "Hello World!";
    return 0;
} 
```

**输出**

```cpp
Hello World! 
```

* * *

## C++ **HelloWorld** 程序的原理

1.  `// Your First C++ Program`

    在 C++ 中，以`//`开头的任何行都是注释。 注释供阅读代码的人员使用，以更好地理解程序的功能。 C++ 编译器完全忽略了它。
2.  `#include <iostream>`

    `#include`是预处理程序指令，用于在程序中包含文件。 上面的代码包括`iostream`文件的内容。

    这使我们可以在程序中使用`cout`在屏幕上打印输出。

    现在，请记住，我们需要使用`#include <iostream>`来使用`cout`，这样我们才能在屏幕上打印输出。
3.  `int main() {...}`

    有效的 C++ 程序必须具有`main()`函数。 花括号指示功能的开始和结束。

    通过此功能执行代码存在。
4.  `std::cout << "Hello World!";`

    `std::cout`打印引号内的内容。 必须在其后跟`<<`，然后是格式字符串。 在我们的示例中，`"Hello World!"`是格式字符串。

    **注意**：`;`用于指示语句的结尾。
5.  `return 0;`

    该语句是程序的“**退出状态**”。 简单来说，程序以该语句结束。

* * *

## 重要结论

*   我们使用`std:cout`以便在屏幕上打印输出。
*   如果要使用`std::cout`，则必须包含`iostream`。
*   代码的执行从`main()`函数开始。 此功能是强制性的。 这是不执行任何操作的有效 C++ 程序。

```cpp
int main() {
    // Write your code here
} 
```