# Kotlin 程序：生成乘法表

> 原文： [https://www.programiz.com/kotlin-programming/examples/multiplication-table](https://www.programiz.com/kotlin-programming/examples/multiplication-table)

#### 在此程序中，您将学习生成给定数字的乘法表。 这是通过在 Kotlin 中使用`for`和`while`循环来完成的。 您还将学习使用范围来解决问题。

## 示例 1：使用`for`循环生成乘法表

```kt
fun main(args: Array<String>) {
    val num = 5

    for (i in 1..10) {
        val product = num * i
        println("$num * $i = $product")
    }
}
```

运行该程序时，输出为：

```kt
5 * 1 = 5
5 * 2 = 10
5 * 3 = 15
5 * 4 = 20
5 * 5 = 25
5 * 6 = 30
5 * 7 = 35
5 * 8 = 40
5 * 9 = 45
5 * 10 = 50
```

与 Java 不同，在上述程序中，我们使用了`range`和`in`运算符来循环从 1 到 10 的数字。

以下是等效的 Java 代码：[生成乘法表的 Java 程序](/java-programming/examples/multiplication-table)。

* * *

还可以使用 Kotlin 中的`while`循环来生成相同的乘法表。

## 示例 2：使用`while`循环生成乘法表

```kt
fun main(args: Array<String>) {
    val num = 9
    var i = 1

    while (i <= 10) {
        val product = num * i
        println("$num * $i = $product")
        i++
    }
}
```

When you run the program, the output will be:

```kt
9 * 1 = 9
9 * 2 = 18
9 * 3 = 27
9 * 4 = 36
9 * 5 = 45
9 * 6 = 54
9 * 7 = 63
9 * 8 = 72
9 * 9 = 81
9 * 10 = 90
```

在上面的程序中，与`for`循环不同，我们必须在循环体内增加`i`的值。

尽管两个程序在技术上都是正确的，但在这种情况下最好使用`for`循环。 这是因为已知迭代次数（从 1 到 10）。