# Python `pass`语句

> 原文： [https://www.programiz.com/python-programming/pass-statement](https://www.programiz.com/python-programming/pass-statement)

#### 在本文中，您将学习`pass`语句。 它用作占位符，用于将来实现功能，循环等。

## 什么是 Python 中的`pass`语句？

在 Python 编程中，`pass`语句为空语句。 Python 中[注释](/python-programming/statement-indentation-comments)和`pass`语句之间的区别在于，尽管解释器完全忽略注释，但`pass`不会被忽略。

但是，执行`pass`时没有任何反应。 结果为无操作（NOP）。

### `pass`语法

```py
pass
```

我们通常将其用作占位符。

假设我们有一个[循环](/python-programming/for-loop)或[函数](/python-programming/function)尚未实现，但我们想在将来实现。 他们不能有一个空的身体。 解释器将给出错误。 因此，我们使用`pass`语句构造一个不执行任何操作的主体。

### 示例：`pass`语句

```py
'''pass is just a placeholder for
functionality to be added later.'''
sequence = {'p', 'a', 's', 's'}
for val in sequence:
    pass
```

我们也可以在空的[函数](/python-programming/function)或[类](/python-programming/class)中执行相同的操作。

```py
def function(args):
    pass
```

```py
class Example:
    pass
```