# Python 程序：将十进制转换为二进制，八进制和十六进制

> 原文： [https://www.programiz.com/python-programming/examples/conversion-binary-octal-hexadecimal](https://www.programiz.com/python-programming/examples/conversion-binary-octal-hexadecimal)

#### 在此程序中，您将学习将十进制转换为二进制，八进制和十六进制，并显示它。

要理解此示例，您应该了解以下 [Python 编程](/python-programming "Python tutorial")主题：

*   [Python 编程内置函数](/python-programming/built-in-function)

* * *

十进制是最广泛使用的数字系统。 但是，计算机只能理解二进制文件。 二进制，八进制和十六进制数系统密切相关，我们可能需要将十进制转换为这些系统。

十进制以 10 为底（十个符号 0-9 用于表示数字），类似地，二进制以 2 为底，八进制以 8 为底，十六进制为 16。

前缀为`0b`的数字被认为是二进制，`0o`被认为是八进制，`0x`被认为是十六进制。 例如：

```py
60 = 0b11100 = 0o74 = 0x3c 
```

## 源代码

```py
# Python program to convert decimal into other number systems
dec = 344

print("The decimal value of", dec, "is:")
print(bin(dec), "in binary.")
print(oct(dec), "in octal.")
print(hex(dec), "in hexadecimal.") 
```

**输出**

```py
The decimal value of 344 is:
0b101011000 in binary.
0o530 in octal.
0x158 in hexadecimal.

```

**注意**：要测试程序的其他十进制数字，请在程序中更改`dec`的值。

在该程序中，我们使用了内置函数`bin()`，`oct()`和`hex()`将给定的十进制数字转换为相应的数字系统。

这些函数采用整数（十进制）并返回字符串。